' Subroutines for iViewNapperLite.

' Global Variables
dim serImgArray()
dim epTitleArray()
dim epListBoxArray()
dim epDescArray()
dim epVideoAssetArray()
docTitle = "iViewNapperLite 20100816"
document.title = docTitle

' Runs when window loads
Sub Window_Onload
  ' Resize Window
  x = 784
  y = 564
  window.resizeTo x, y

  ' Centre Window
  x = (window.screen.width - x) / 2
  y = (window.screen.height - y) / 2
  If x < 0 Then x = 0
  If y < 0 Then y = 0
  window.moveTo x, y

  ' Get A-L JSON file
  j1 = getURL("http://173.230.146.115/iview/api/?keyword=a-l")
  j1 = left(j1, len(j1) - 1)

  ' Get M-Z JSON file
  j2 = getURL("http://173.230.146.115/iview/api/?keyword=m-z")
  j2 = right(j2, len(j2) - 1)

  ' Combine JSON files and Deserialize
  set myJSON = JSON.parse(j1 & "," & j2)

  ' Prosess JSON and Populate Listbox
  num = 0
  for each show in myJSON
    num = num + show.[5].length
  next

  ' Populate arrays
  redim serImgArray(num)
  redim epTitleArray(num)
  redim epListBoxArray(num)
  redim epDescArray(num)
  redim epVideoAssetArray(num)
  counter = 0
  for each show in myJSON
    ' Do not add shopdownload episodes
    if show.[4] <> "shopdownload" then
      for each episode in show.[5]
        serImgArray(counter) = show.[3]
        ' Video Asset
        va = episode.[13]
        epVideoAssetArray(counter) = va
        ' Episode Title
        t2 = episode.[1]
        t2 = Replace(t2, "&amp;", "and")
        t2 = Replace(t2, "/", "-")
        t2 = Replace(t2, ":", " -")
        t2 = Replace(t2, "?", "")
        t2 = Replace(t2, chr(9), " ")
        t2 = left(t2, 75)
        epTitleArray(counter) = t2
        ' File Size
        sz = episode.[8]
        sz = IIf(sz = "", "UNKNOWN", sz + " MB")
        ' Duration
        du = "0" & episode.[9]
        du = cstr(Int(du / 60))
        du = IIf(du = "0", "UNKNOWN", du + " min")
        epListBoxArray(counter) = padright(t2, 75) & padright(padleft(du, 8), 9) & padleft(sz, 8)
        ' Short Title
        st = episode.[2]
        st = Replace(st, "&amp;", "and")
        st = st + IIf(len(st) > 0, " ", "")
        ' pubDate
        pd = episode.[5]
        pd = "(" & split(pd)(0) & ") "
        ' Description
        ds = episode.[3]
        ds = replace(ds, "&lt;", "<")
        ds = replace(ds, "&gt;", ">")
        ds = replace(ds, "&quot;", "'")
        ds = replace(ds, chr(13), "")
        ds = replace(ds, chr(10), "")
        ds = trim(ds)
        ex = " [" & UCase(Right(va, 3)) & "] "
        epDescArray(counter) = st & pd & ds & ex
        counter = counter + 1
      next
    end if
  next
  counter = counter - 1
  redim preserve serImgArray(counter)
  redim preserve epTitleArray(counter)
  redim preserve epDescArray(counter)
  document.title = docTitle & " - " & counter & " episodes"

  ' Sort arrays alphabetically on episode titles
  for i = UBound(epTitleArray) - 1 To 0 Step -1
    for j= 0 to i
      if epTitleArray(j)>epTitleArray(j+1) then
        ' Sort serImgArray
	temp=serImgArray(j+1)
        serImgArray(j+1)=serImgArray(j)
        serImgArray(j)=temp
        ' Sort epTitleArray
	temp=epTitleArray(j+1)
        epTitleArray(j+1)=epTitleArray(j)
        epTitleArray(j)=temp
        ' Sort epListBoxArray
	temp=epListBoxArray(j+1)
        epListBoxArray(j+1)=epListBoxArray(j)
        epListBoxArray(j)=temp
        ' Sort epDescArray
        temp=epDescArray(j+1)
        epDescArray(j+1)=epDescArray(j)
        epDescArray(j)=temp
        ' Sort epVideoAssetArray
        temp=epVideoAssetArray(j+1)
        epVideoAssetArray(j+1)=epVideoAssetArray(j)
        epVideoAssetArray(j)=temp
      end if
    next
  next

  ' Populate listbox
  for i = 0 To UBound(epTitleArray) - 1
    dim opt
    set opt = document.createelement("option")
    opt.text = epListBoxArray(i)
    listbox.add opt
    set opt = nothing
  next

  ' Salect first episode
  document.getElementById("listbox").selectedIndex = 0
  listbox_onclick(0)

End Sub

' listbox on single click event
Sub listbox_onclick(num)
  if isNumeric(num) then
    document.getElementById("textbox").value = epDescArray(num)
    document.getElementById("picbox").src = serImgArray(num)
  end if
End Sub

' listbox on change event
Sub listbox_onchange
  listbox_onclick(document.getElementById("listbox").selectedIndex)
End Sub

' picbox on double click event
Sub picbox_ondblclick
  fetchEpisode
End Sub

' Clears the listbox box
Sub clear_listbox
  document.getElementById("listbox").options.length = 0
End Sub

Sub fetchEpisode
  ' URL for ABC authentication server
  'URL = "http://www2b.abc.net.au/iView/Services/iViewHandshaker.asmx/isp"
  URL = "http://www2b.abc.net.au/iViewHandshaker/services/iviewhandshaker.asmx/isp"

  ' Extract token and other values
  set xmlDoc=CreateObject("Microsoft.XMLDOM")
  xmlDoc.async="false"
  xmlDoc.load(URL)
  token = xmlDoc.documentElement.selectSingleNode("/iview/token").text
  host = xmlDoc.documentElement.selectSingleNode("/iview/host").text
  free = xmlDoc.documentElement.selectSingleNode("/iview/free").text
  set xmlDoc = Nothing

  ' Init some content server param vars
  num = document.getElementById("listbox").selectedIndex
  show = left(epVideoAssetArray(num), len(epVideoAssetArray(num)) - 4)
  ext = Right(epVideoAssetArray(num), 3)

  ' Setup the content server params for host
  x = "rtmpdump-win32-2.2d.exe"
  o = " -o " & """" & epTitleArray(num) & "." & ext & """"
  W = " -W ""http://www.abc.net.au/iview/images/iview.jpg"""
  z = ""
  Select Case Ucase(host)
    Case  "HOSTWORKS"
      r = " -r rtmp://203.18.195.10/"
      asset = iif(ext="mp4", "&mp4:" & show, "")
      a = " -a ondemand?auth=""" & token  & asset & """"
      show = iif(ext = "mp4", "mp4:", "") & show
      y = " -y " & """" & show & """"
      cmd = x & r & a & y & o & W & z
    Case "AKAMAI"
      show = iif(ext = "mp4", show & "." & ext, show)
      r = " -r rtmp://cp53909.edgefcs.net////flash/playback/_definst_/" & show
      t = " -t rtmp://cp53909.edgefcs.net/ondemand?auth=""" & token & """"
      cmd = x & r & t & o & W & z
    Case Else
      msgbox "Content server not listed."
  End Select

  ' Spawn DOS shell and run app
  Set wshShell = CreateObject("WScript.Shell")
  wshShell.Run cmd
  Set wshShell = Nothing
  Set xmlDoc = Nothing
End Sub ' fetch

' Immediate IF function.
Function iif(tstStr, trueStr, falseStr)
  if tstStr then
    iif = trueStr
  else
    iif = falseStr
  end if
End Function

' Padleft function.
Function padleft(str, num)
  padleft = space(num - len(str)) & str
End Function

' Padright function.
Function padright(str, num)
  padright = str & space(num - len(str))
End Function

' Gets the file from the internet.
Function getURL(URL)
  dim http
  set http = CreateObject("Microsoft.XMLHTTP")
  http.Open "GET", URL, false
  http.Send
  getURL = http.ResponseText
End Function
